lab_1/urls.py
from django.urls import path
from .views import friend_list, index

urlpatterns = [
    path('', index, name='index'),
    # TODO Add friends path using friend_list Views
    path('friends',friend_list)
    
]

lab_2/urls.py
from django.urls import path
from .views import index, xml, json

urlpatterns = [
    path('', index),
    path('xml',xml),
    path('json',json)

    
    
]

lab_3/urls.py
from django.urls import path
from .views import index, add_friend

urlpatterns = [
    path('', index),
    path('add', add_friend)
    

    
    
]

lab_4/urls.py
from django.urls import path
from .views import index, add_note, nav, note_list

urlpatterns = [
    path('', index, name="lab4-index"),
    path('add-note',add_note, name="add-note"),
    path('note-list', note_list, name="note-list"),
    path('nav',nav)
    

    
    
]

lab_5/urls.py
from django.urls import path
from .views import index

urlpatterns = [
    path('', index),
    

    
    
]

praktikum/urls.py
from django.urls import path, re_path, include
from django.contrib import admin
import lab_1.urls as lab_1
from lab_1.views import index as index_lab1

urlpatterns = [
    path('admin/', admin.site.urls),
    path('lab-1/', include('lab_1.urls')),
    path('lab-2/', include('lab_2.urls')),
    path('lab-3/', include('lab_3.urls')),
    path('lab-4/', include('lab_4.urls')),
    path('lab-5/', include('lab_5.urls')),


    re_path(r'^$', index_lab1, name='index')
    
]

lab_1/models.py
from django.db import models
from datetime import datetime, date

# TODO Create Friend model that contains name, npm, and DOB (date of birth) here


class Friend(models.Model):
    name = models.CharField(max_length=30)
    # TODO Implement missing attributes in Friend model
    npm = models.IntegerField()
    DOB = models.DateField()

    def __str__(self):
        return self.name

lab_2/models.py
from django.db import models

# Create your models here.
class Note(models.Model):
    receiver = models.CharField(max_length=20)
    sender = models.CharField(max_length=20)
    title = models.CharField(max_length=40)
    message = models.TextField()

    def __str__(self):
        return self.title

lab_3/models.py
from django.db import models

# Create your models here.

lab_4/models.py
from django.db import models

# Create your models here.

lab_5/models.py
from django.db import models

# Create your models here.

lab_3/forms.py
from django.forms import ModelForm
from lab_1.models import Friend

class FriendForm(ModelForm):
    class Meta:
        model = Friend
        fields = ['name','npm','DOB']

lab_4/forms.py
from django.forms import ModelForm
from lab_2.models import Note

class NoteForm(ModelForm):
    class Meta:
        model = Note
        fields = ['receiver','sender','title','message']

lab_1/views.py
from lab_1.models import Friend
from django.shortcuts import render
from datetime import datetime, date
from .models import Friend

mhs_name = 'Retadha Rumi Indika Hidayat'  # TODO Implement this
curr_year = int(datetime.now().strftime("%Y"))
birth_date = date(2002,3,1)  # TODO Implement this, format (Year, Month, Date)
npm = 2006485314  # TODO Implement this


def index(request):
    response = {'name': mhs_name,
                'age': calculate_age(birth_date.year),
                'npm': npm}
    return render(request, 'index_lab1.html', response)


def calculate_age(birth_year):
    return curr_year - birth_year if birth_year <= curr_year else 0


def friend_list(request):
    friends = Friend.objects.all()  # TODO Implement this
    response = {'friends': friends}
    return render(request, 'friend_list_lab1.html', response)

lab_2/views.py
from django.shortcuts import render
from .models import Note
from django.http.response import HttpResponse
from django.core import serializers

# Create your views here.
def index(request):
    notes = Note.objects.all()
    response = {'notes':notes}
    return render(request, 'lab2.html', response)

def xml(request):
    data = serializers.serialize('xml', Note.objects.all())
    return HttpResponse(data, content_type="application/xml")

def json(request):
    data = serializers.serialize('json', Note.objects.all())
    return HttpResponse(data, content_type="application/json")
    

lab_3/views.py
from django.http import response, HttpResponseRedirect
from django.shortcuts import redirect, render
from lab_1.models import Friend

from lab_3.forms import FriendForm
from django.contrib.auth.decorators import login_required



# Create your views here.
@login_required(login_url='/admin/login/')
def index(request):
      # TODO Implement this
    friends = Friend.objects.all()
    response = {'friends':friends}
    return render(request, 'lab3_index.html', response)

@login_required(login_url='/admin/login/')
def add_friend(request):
  form = FriendForm(request.POST or None)
  if request.method == 'POST':
    if (form.is_valid() and request.method == 'POST'):
      form.save()
      return HttpResponseRedirect('/lab-3')
    


  
  response = {'form':form}
  return render(request, 'lab3_form.html',response)

lab_4/views.py
from django.shortcuts import render
from django.http import response, HttpResponseRedirect
from lab_2.models import Note
from lab_4.forms import NoteForm

# Create your views here.
def index(request):
    notes = Note.objects.all()
    response = {'notes':notes}
    return render(request, 'lab4_index.html', response)

def nav(request):
    response = {}
    return render(request, 'base.html', response)

def add_note(request):
  form = NoteForm(request.POST or None)
  if request.method == 'POST':
    if (form.is_valid() and request.method == 'POST'):
      form.save()
      return HttpResponseRedirect('/lab-4')
    

  response = {'form':form}
  return render(request, 'lab4_form.html', response)

def note_list(request):
    notes = Note.objects.all()
    response = {'notes':notes}
    return render(request, 'lab4_note_list.html', response)

lab_5/views.py
from django.shortcuts import render
from lab_2.models import Note

# Create your views here.
def index(request):
    notes = Note.objects.all()
    response = {'notes':notes}
    return render(request, 'lab5_index.html', response)

lab_1/templates/friend_list_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      <!-- TODO loop from Friend model -->
      {% for friend in friends %}   
      <tr>
        <td>{{friend.name}}</td>
        <td>{{friend.npm}}</td>
        <td>{{friend.DOB}}</td>
      </tr>
      {% endfor %}
      <!-- EXAMPLE SECTION -->
      <tr>
        <td>Asmara Nugi</td>
        <td>1706032156</td>
        <td>May 1, 1999</td>
      </tr>
      <tr>
        <td>Fadli Rais</td>
        <td>1706032370</td>
        <td>Sept 11, 1998</td>
      </tr>
      <!-- END SECTION -->
    </table>
  </body>
</html>

lab_1/templates/index_lab1.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>{{ name }}</title>
  </head>
  <body>
    <h1>Hello my name is {{ name }}</h1>
    <article>NPM : {{ npm }}</article>
    <article>I am {{ age }} years old</article>
  </body>
</html>

lab_2/templates/lab2.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Note List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>From</th>
        <th>To</th>
        <th>Title</th>
        <th>Message</th>
      </tr>
      <!-- TODO loop from Friend model -->
      {% for note in notes %}   
      <tr>
        <td>{{note.sender}}</td>
        <td>{{note.receiver}}</td>
        <td>{{note.title}}</td>
        <td>{{note.message}}</td>
      </tr>
      {% endfor %}
      <!-- EXAMPLE SECTION -->
      <!-- END SECTION -->
    </table>
  </body>
</html>

lab_3/templates/lab3_form.html
<!DOCTYPE html>
<html>
    <head>
        <title>Friend Form</title>
    </head>

    
    <body>
        <h1>Friend Form</h1>
        <form method="POST" action="">
            {%csrf_token%}
            {{form.as_p}}
            <button type="submit" value="submit">Submit</button>
        </form>
    </body>
    
</html>

lab_3/templates/lab3_index.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Friend List</title>
  </head>
  <body>
    <table>
      <tr>
        <th>Name</th>
        <th>NPM</th>
        <th>DOB</th>
      </tr>
      <!-- TODO loop from Friend model -->
      
      {% for friend in friends %}   
      
      <tr>
        <td>{{friend.name}}</td>
        <td>{{friend.npm}}</td>
        <td>{{friend.DOB}}</td>
      </tr>
      {% endfor %}
    
      <!-- EXAMPLE SECTION -->
      <tr>
        <td>Asmara Nugi</td>
        <td>1706032156</td>
        <td>May 1, 1999</td>
      </tr>
      <tr>
        <td>Fadli Rais</td>
        <td>1706032370</td>
        <td>Sept 11, 1998</td>
      </tr>
      <!-- END SECTION -->
    </table>
  </body>
</html>

lab_4/templates/base.html
{% load static %}
<!DOCTYPE html>
<html>
    <head>
        <title>{% block title %} Judul{% endblock title %}</title>
        <link rel="stylesheet" href="{% static 'css/bootstrap.min.css' %}">
        <link rel="stylesheet" href="{% static 'css/bootstrap.css' %}">
        
        
    </head>
    <body>
        <style>
            body {
                font-size: 20px;
            }
        </style>
        <nav class="navbar navbar-expand-lg navbar-light bg-light">

        
        <ul class="navbar-nav">
            <li class="nav-item">
                <a class="nav-link" href="{% url 'lab4-index' %}">Note Table</a>
            </li>

            <li class="nav-item">
                <a class="nav-link" href="{% url 'add-note' %}">Fill Form</a>
            </li>

            <li class="nav-item">
                <a class="nav-link" href="{% url 'note-list' %}">Note Card</a>
            </li>
            
        </ul>  
        
    </nav>
            
        
        
        {% block content %}
        {% endblock content %}

        

    </body>
</html>

lab_4/templates/lab4_form.html
{% extends 'base.html' %}

{% block title %} Notes Form {% endblock title %}
{% block content %}

<style>
    

    form {
        text-align: center;
        font-size: 30px;
        background-color: #00FFFF;
        width: 500px;
        margin: 0 auto 0 auto;
    }

    h1 {
        
        text-align: center;
        background-color: #00FFFF;
        width: 500px;
        margin: 50px auto 0 auto;
        
        
    }

</style>
<h1>Note Form</h1>

<form method="POST" action="" >
{%csrf_token%}

<div class="field">
 <label for="id_receiver" class="form-label">Receiver :</label>
 <input id="id_receiver" type="text" name="receiver" required></input>
</div>

<div class="field">
 <label for="id_sender" class="form-label">From :</label>
 <input id="id_sender" type="text" name="sender" required></input>
</div>

<div class="field">
 <label for="id_title" class="form-label">Title :</label>
 <input id="id_title" type="text" name="title" required></input>
</div>

<div class="field">
 <label for="id_message" class="form-label">Message</label>
 <textarea name="message" id="id_message" required></textarea>
</div>

<button type="submit" value="submit">Submit</button>

</form>


{% endblock %}

lab_4/templates/lab4_index.html
{% extends 'base.html' %}

{% block title %} Notes Table {% endblock title %}
{% block content %}
<table class="table table-striped table-bordered">
  <thead>
  <tr class="table-primary">
    <th scope="col">From</th>
    <th scope="col">To</th>
    <th scope="col">Title</th>
    <th scope="col">Message</th>
  </tr>
</thead>
  <!-- TODO loop from Friend model -->
  
  <tbody>
  {% for note in notes %}  
  <tr>
    <td>{{note.sender}}</td>
    <td>{{note.receiver}}</td>
    <td>{{note.title}}</td>
    <td>{{note.message}}</td>
  </tr>
  {% endfor %}
</tbody>
  </table>
  
  {% endblock %}
  
  
    

lab_4/templates/lab4_note_list.html
{% extends 'base.html' %}

{% block title %} Notes Table {% endblock title %}
{% block content %}

<div class="card-columns">
{% for note in notes %}
  <div class="card border-warning" style="width: 300px;">
    <div class="card-header bg-warning">
      Pengirim: {{note.sender}}
    </div>
    <div class="card-header bg-light">
      Penerima: {{note.receiver}}
    </div>
    <div class="card-body">
      <h5 class="card-title">{{note.title}}</h5>
      <p class="card-text">{{note.message}}</p>
    </div>
  </div>
<br>
{% endfor %}
</div>
{% endblock %}
  
  
    

lab_5/templates/lab5_index.html
{% load static %}

<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Note List</title>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <link rel="stylesheet" href="{% static 'style.css' %}">
    <script type="application/javascript" src="https://cdn.jsdelivr.net/npm/bootstrap@5.1.3/dist/js/bootstrap.bundle.min.js"></script>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="{% static 'script.js' %}"></script>
    
  </head>
  <body>
    
    <h1 class="display-1 bg-dark text-white">Note List</h1>
    
    <div class="table-container">
    <table class="table table-dark table-bordered" id="table-attribute">
      <thead class="table-dark">
      <tr>
        <th>From</th>
        <th>To</th>
        <th>Title</th>
        <th>Message</th>
        <th>Action</th>
      </tr>
      </thead>
      
      <tbody>
        
      
      </tbody>
    </table>
    </div>
  </body>
</html>